##
# DBM::Deep Test
##
use strict;
use Test::More tests => 6;
use Test::Exception;
use t::common qw( new_fh );

use_ok( 'DBM::Deep' );

my ($fh, $filename) = new_fh();
my $db = DBM::Deep->new( $filename );

$db->{foo} = '1234';
$db->{foo} = '2345';

my $size = -s $filename;
$db->{foo} = '3456';
cmp_ok( $size, '==', -s $filename, "A second overwrite doesn't change size" );

$size = -s $filename;
delete $db->{foo};
cmp_ok( $size, '==', -s $filename, "Deleted space isn't released" );

$size = -s $filename;
$db->{bar} = '2345';
cmp_ok( $size, '==', -s $filename, "Added a new key after a delete reuses space" );

$db->{baz} = {};
$size = -s $filename;

delete $db->{baz};
$db->{baz} = {};

cmp_ok( $size, '==', -s $filename, "delete and rewrite reuses space" );

$db->{baz} = {};
$size = -s $filename;

$db->{baz} = {};

cmp_ok( $size, '==', -s $filename, "delete and rewrite reuses space" );
